#!/bin/sh
# The the next line is executed by the shell only \
exec wish8.3 "$0" ${1+"$@"}

proc SetupGUI {} {
  . config -width 800 -height 28
  wm minsize . 800 28
  wm maxsize . 800 28
  button .e -text Exit -relief flat -command {
    close $serial
    exit
  }
  button .p -text Paste -relief flat -command {
    foreach char [split [selection get -selection CLIPBOARD] {}] {
      puts -nonewline $serial [binary format ca $scancode(ASCII) $char]
    }
  }
  button .a -text About -relief flat -command {
    tk_messageBox -type ok -icon info -title {EasyType Simulation} \
      -message "EasyType Simulation\n(Tcl/Tk version)\nCopyright (c)2001\nAll \
       rights reserved\nMac A. Cody"
  }
  pack .e .p .a -side left
  bind . <KeyPress> {puts -nonewline $serial [binary format c $scancode(%k)]}
  bind . <KeyRelease> {puts -nonewline $serial \
    [binary format c [expr 0x80 | $scancode(%k)]]}
  focus .
}

proc SetupSerial device {
  if {[catch [list open $device r+] serial]} {
    tk_messageBox -type ok -icon error -title {EasyType Simulation} \
      -message "Failure on opening selected serial device"
    exit
  }
  fconfigure $serial -mode "2400,n,8,1"
  fconfigure $serial -blocking 0 -buffering none -translation binary -eofchar {}
  return $serial
}

array set scancode {75 0x01 ASCII 0x02 71 0x03 69 0x04 67 0x05 68 0x06 96 0x07
76 0x09 74 0x0a 72 0x0b 70 0x0c 23 0x0d 49 0x0e 64 0x11 50 0x12 37 0x14 24 0x15
10 0x16 52 0x1a 39 0x1b 38 0x1c 25 0x1d 11 0x1e 54 0x21 53 0x22 40 0x23 26 0x24
13 0x25 12 0x26 65 0x29 55 0x2a 41 0x2b 28 0x2c 27 0x2d 14 0x2e F17 0x2f
107 0x30 57 0x31 56 0x32 43 0x33 42 0x34 29 0x35 15 0x36 F13 0x37 F18 0x38
113 0x39 58 0x3a 44 0x3b 30 0x3c 16 0x3d 17 0x3e F14 0x3f F22 0x40 59 0x41
45 0x42 31 0x43 32 0x44 19 0x45 18 0x46 97 0x47 102 0x48 60 0x49 61 0x4a
46 0x4b 47 0x4c 33 0x4d 20 0x4e 117 0x4f 115 0x50 116 0x51 48 0x52 F19 0x53
34 0x54 21 0x55 F16 0x56 100 0x57 66 0x58 62 0x59 36 0x5a 35 0x5b 98 0x5c
51 0x5d 104 0x5e F21 0x5f 106 0x60 PIPE 0x61 F20 0x62 103 0x63 99 0x64 105 0x65
22 0x66 111 0x67 112 0x68 87 0x69 109 0x6a 83 0x6b 79 0x6c 108 0x6d 73 0x6e
110 0x6f 90 0x70 91 0x71 88 0x72 84 0x73 85 0x74 80 0x75 9 0x76 77 0x77 95 0x78
86 0x79 89 0x7a 82 0x7b 63 0x7c 81 0x7d 78 0x7e}

if {$argc > 0} {
  set device [lindex $argv 0]
} else {
  set device /dev/pilot
}
set serial [SetupSerial $device]
SetupGUI
